
#include <iostream>
#include "events.hpp"

using namespace capi;
using namespace std;

class SubEvent : public Event
{
public:
    SubEvent(void) : Event(Event::NOTIFY) {}
};

class MyEventListener : public EventListener
{
public:
    EventDispatcher* e;
	MyEventListener(EventDispatcher* c) : e(c) { static int st_index = 0; index = st_index++; }
	MyEventListener(const MyEventListener& e) : index(e.index) {}
	virtual void eventPerformed(Event* evt) 
    { 
        cout << "Received (" << index << ") : " << evt->getType()->name << endl; 
        
        if (e != NULL) {
            e->addListener(evt->getType(), new MyEventListener(NULL));
        }
    }

private:
	int index;
};

int main()
{
	/*EventDispatcher* e = new EventDispatcher();

	EventType<EventListener*>* t = new EventType<EventListener*>("event1");
	EventType<EventListener*>* u = new EventType<EventListener*>("event2");

	e->addListener(t, new EventListener());
	e->addListener(t, new EventListener(), 100);
	e->addListener(t, new EventListener(), 30);
	e->addListener(t, new EventListener(), 100);

	e->addListener(u, new EventListener());
	e->addListener(u, new EventListener());

	cout << "Event " << t->name << endl;
	e->dispatchEvent(new MyEvent(t));
	cout << endl << "Event " << u->name << endl;
	e->dispatchEvent(new MyEvent(u));

	cout << endl << "Clear listeners of " << u->name << endl;
	e->clear(u);

	cout << endl << "Event " << t->name << endl;
	e->dispatchEvent(new MyEvent(t));
	cout << endl << "Event " << u->name << endl;
	e->dispatchEvent(new MyEvent(u));

	delete e;*/

	EventDispatcher* e = new EventDispatcher();
	
	e->addListener(Event::NOTIFY, new MyEventListener(e));
	//e->dispatchEvent(new Event(Event::NOTIFY));
    e->dispatchEvent(new SubEvent());
    e->dispatchEvent(new SubEvent());
    e->dispatchEvent(new SubEvent());

	delete e;

	return 0;
}

